#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "SatoLabelAPI.h"
#include "SatoConst.h"


int connectToPrinter()
{
	int input;
	int ret;
	char port[128] = {0x00, };

	printf("\n\t [Connect to the SATO printer] \n");
	printf("\t\t  1.USB\n");
	printf("\t\t  2.Serial\n");
	printf("\t\t  3.Bluetooth\n");
	printf("\t\t  4.Ethernet/WLAN\n");
	printf("\t\t  5.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("Please select the connected interface with the printer.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = ConnectToPrinter("USB:");
		}
		else if (2 == input)
		{
			unsigned long baudrate = 0;

			printf("\nPlease input serial I/F\n");
			scanf("%s", port);

			// input type
			// serial:baudrate
			// /dev/ttySX:baudrate
			ret = ConnectToPrinter(port);
		}
		else if (3 == input)
		{
			while (1)
			{
				printf("\nPlease input the mac address of bluetooth priner\n");
				printf("Input the address : ");
				scanf("%s", port);

				if (':' == port[2] && ':' == port[5] && ':' == port[8] &&
						':' == port[11] && ':' == port[14])
				{
					break;
				}

				printf("\nWrong input.\n");
			}

			// input type
			// xx:xx:xx:xx:xx:xx
			ret = ConnectToPrinter(port);
		}
		else if (4 == input)
		{
			char *tmp;

			while (1)
			{
				printf("\nPlease input the IP address of Ethernet or Wlan printer\n");
				printf("Input the address : ");
				scanf("%s", port);

				tmp = strchr(port, ':');
				if (NULL == tmp)
				{
					printf("\nWrong input.\n");

					continue;
				}

				break;
			}

			// input type
			// xxx.xxx.xxx.xxx:xxxx
			ret = ConnectToPrinter(port);
		}
		else if (5 == input)
		{
			return input;
		}
		else 
		{
			printf("\nWrong input.\n\n");

			continue;
		}


		if (SUCCESS == ret)
		{
			break;
		}
		else
		{
			printf("\nFailed to connect to the printer.\n");
			sleep(1);
		}
	}

	printf("\nSuccessed to connect to the printer.\n");
	sleep(1);

	return ret;
}

int setProperties()
{
	int input;
	//int ret = SUCCESS;

	printf("\n\t [Set the Properties of the printer] \n");
	printf("\t\t  1.Speed\n");
	printf("\t\t  2.Density\n");
	printf("\t\t  3.Orientation\n");
	printf("\t\t  4.Paper\n");
	printf("\t\t  5.Margin\n");
	printf("\t\t  6.Offset\n");
	printf("\t\t  7.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\n Please select the property to set.\n");
		printf(" Input number : ");
		scanf("%d", &input);


		if (1 == input)		// speed
		{
			int speed;

			printf("[Set Printing Speed]\n");
			printf("\n");
			printf("1. 2.5 ips\n");
			printf("2. 3.0 ips\n");
			printf("3. 4.0 ips\n");
			printf("4. 5.0 ips\n");
			

			printf("\nInput number : ");
			scanf("%d", &speed);

			if (1 == speed)
			{
				SetSpeed(SPEED_25);
			}
			else if (2 == speed)
			{
				SetSpeed(SPEED_30);
			}
			else if (3 == speed)
			{
				SetSpeed(SPEED_40);
			}
			else if (4 == speed)
			{
				SetSpeed(SPEED_50);
			}
			else
			{
				SetSpeed(SPEED_50);
			}

		}
		else if (2 == input)	// density
		{
			int density; 

			printf("[Set Printing Density]\n");
			printf("\n");
			printf("Input density (0 ~ 20) : ");
			scanf("%d", &density);

			SetDensity(density);
		}
		else if (3 == input)	// orientation
		{
			int orientation;

			printf("[Set Printing Orientation]\n");
			printf("\n");
			printf("1. Top to Bottom\n");
			printf("2. Bottom to Top\n");

			printf("\nInput number : ");
			scanf("%d", &orientation);

			if (2 == orientation)
			{
				SetOrientation(BOTTOM_TO_TOP);
			}
			else
			{
				SetOrientation(TOP_TO_BOTTOM);
			}
		}
		else if (4 == input)	// paper
		{
			// paper width 832 dot
			// paper height 1216 dot
			// GAP paper
			// GAP length 20 dot
			// offset 0
			SetPaper(832, 1216, MEDIA_GAP, 20, 0);
		}
		else if (5 == input)	// margin
		{
			int hMargin, vMargin;

			printf("[Set Margin]\n");
			printf("\n");
			printf("Input Horizontal Margin : ");
			scanf("%d", &hMargin);
			printf("\n");
			printf("Input Vertical Margin : ");
			scanf("%d", &vMargin);

			SetMargin(hMargin, vMargin);
		}
		else if (6 == input)	// offset
		{
			int offset;

			printf("[Set Offset]\n");
			printf("\n");
			printf("Input Offset : ");
			scanf("%d", &offset);

			SetOffset(offset);
		}
		else if (7 == input)
		{
			return input;
		}
		else
		{
			printf("\nWrong input.\n\n");

			continue;
		}
	}

	return SUCCESS;
}


int printText()
{
	PrintDeviceFont("DEVICE FONT TEST", 30, 50, DEVICE_ENG_9X15, 1, 1, ROTATE_0, false);
	PrintDeviceFont("日本語のテストです。", 30, 100, DEVICE_JPN_JIS, 1, 1, ROTATE_0, false);
	PrintDeviceFont("한국어 인쇄 테스트", 30, 150, DEVICE_KOR_24X24, 1, 1, ROTATE_0, false);
	PrintDeviceFont("你好。印刷测试。", 30, 200, DEVICE_CHN_GB2312, 1, 1, ROTATE_0, false);
	PrintDeviceFont("你好。印刷測試。", 30, 250, DEVICE_CHN_BIG5, 1, 1, ROTATE_0, false);
	Prints(1, 1);

	PrintVectorFont("VECTOR FONT TEST", 30, 50, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintVectorFont("日本語のテストです。", 30, 100, VECTOR_JIS, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintVectorFont("한국어 인쇄 테스트", 30, 150, VECTOR_KS5601, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintVectorFont("你好。印刷测试。", 30, 200, VECTOR_GB2312, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintVectorFont("你好。印刷測試。", 30, 250, VECTOR_BIG5, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	Prints(1, 1);

	return SUCCESS;
}


int print1DBarcode()
{
	PrintVectorFont("CODE 39", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_CODE39, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("CODE 128", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_CODE128, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("Interleaved 2of5", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_I2OF5, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("CODABAR", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_CODABAR, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("CODE 93", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_CODE93, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("UPC-A", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_UPCA, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("UPC-E", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_UPCE, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("EAN 13", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_EAN13, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("EAN 8", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_EAN8, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("EAN 128", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_EAN128, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);

	return SUCCESS;
}

int print2DBarcode()
{
	PrintVectorFont("MAXICODE", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintMaxiCode("990,840,06840,THIS IS A TEST OF MODE 0 SATO LABEL PRINTER", 70, 90, MAXICODE_MODE0);


	PrintVectorFont("PDF417", 70, 340, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintPDF417("SATO Label Printer, This is Test Printing", 70, 390, 30, 5, PDF417_ECL0, 
				PDF417_COMP_TEXT, true, 1, 3, 10, 0);

	Prints(1, 1);


	PrintVectorFont("QR Code", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintQRCode("ABCDEFGHIJKLMN1234567890", 70, 90, 1, QRCODE_ECC7, 4, ROTATE_0);


	PrintVectorFont("Data Matrix", 70, 240, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintDataMatrix("SATO Label Printer", 70, 290, 4, false, ROTATE_0);

	Prints(1, 1);


	PrintVectorFont("Aztec", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintAztec("THIS IS AZTEC BARCODE TEST", 70, 90, 5, 0, 0, true, 1, 1, ROTATE_0);

	PrintVectorFont("Code 49", 70, 240, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintCode49("12345ABC", 70, 290, 2, 7, 22, 2, 7, ROTATE_0);

	Prints(1, 1);

	PrintVectorFont("Micro PDF", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintMicroPDF("ABCDEFGHIJKLMN1234567890", 70, 90, 2, 6, 8, ROTATE_0);

	Prints(1, 1);

	return SUCCESS;
}

int printSample()
{	
	PrintBlock(8, 80, 568, 88, BLOCK_OVERWRITE, 0);
	PrintDeviceFont("SHIP TO:", 16, 96, DEVICE_ENG_24X38, 1, 1, ROTATE_0, false);
	PrintDeviceFont("SATO", 16, 136, DEVICE_ENG_19X30, 1, 1, ROTATE_0, false);
	PrintDeviceFont("7th FL, MiraeAsset Venture Tower,", 16, 168, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("685, Sampyeong-dong, Bundang-gu,", 16, 192, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("Seongnam-si, Gyeonggi-do,", 16, 216, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("463-400, KOREA", 16, 240, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	
	PrintDeviceFont("POSTAL CODE", 24, 288, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	Print1DBarcode("1234567890", 24, 320, BAR_CODE39, 4, 6, 48, ROTATE_0, false);
	PrintDeviceFont("AWB:", 24, 400, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	Print1DBarcode("8741493121", 24, 424, BAR_CODE93, 4, 8, 90, ROTATE_0, false);
	
	PrintDeviceFont("WEIGHT:", 32, 552, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DELIVERY NO:", 232, 552, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DESTINATION", 424, 552, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("30Kg", 24, 584, DEVICE_ENG_32X50, 1, 1, ROTATE_0, false);
	PrintDeviceFont("425518", 208, 584, DEVICE_ENG_32X50, 1, 1, ROTATE_0, false);
	PrintDeviceFont("ICN", 440, 584, DEVICE_ENG_32X50, 1, 1, ROTATE_0, true);
	
	PrintDataMatrix("SATO Label Printer", 280, 664, 4, false, ROTATE_0);
	PrintQRCode("QRCode sample test 123", 400, 664, 2, QRCODE_ECC15, 4, ROTATE_0); 
	PrintPDF417("SATO Label Printer, This is Test Printing", 16, 776, 8, 8, PDF417_ECL0, PDF417_COMP_TEXT, false, 1, 3, 14, 0);
	PrintBlock(8, 640, 568, 896, BLOCK_BOX, 3);

	Prints(1, 1);

	return SUCCESS;
}

int main(void)
{
	int menu_flag = 0;
	int ret;

	int input;
	int status;

	while (1)
	{
		system("clear");
		printf("\n\n   [SATO Label Printer SDK Sample]   \n\n");

		if (0 == menu_flag)
		{
			printf("\t 1. Connect to the printer\n");
		}
		else 
		{
			printf("\t 1. Connect to the printer\n");
			printf("\t  - Connected!\n");
		}
		printf("\t 2. Set Properties\n");
		printf("\t 3. Print Sample\n");
		printf("\t 4. Print Text\n");
		printf("\t 5. Print Barcode\n");
		printf("\t 6. Print Image\n");
		printf("\t 7. Print Block\n");
		printf("\t 8. Check Status\n");
		printf("\t 9. Calibrate Media\n");
		printf("\t 10. Exit\n");

		printf("  input number : ");
		scanf("%d", &input);


		if (1 == input)		// connect to the printer
		{
			ret = connectToPrinter();
			if (6 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");

				return -1;
			}

			menu_flag = 1;
		}
		else if (2 == input) 	// set properties
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = setProperties();
			if (10 == ret )
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");
				continue;
			}

			menu_flag = 2;
		}
		else if (3 == input) 	// print sample
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			
			printSample();

			menu_flag = 3;
		}
		else if (4 == input) 	// print text
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = printText();

			menu_flag = 4;
		}
		else if (5 == input) 	// print barcode
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			print1DBarcode();
			print2DBarcode();

			menu_flag = 5;
		}
		else if (6 == input) 	// print image
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			PrintBitmap("image.bmp", 50, 50, false);
			PrintBitmap("image.bmp", 50, 350, true);
			Prints(1, 1);

			menu_flag = 6;
		}
		else if (7 == input) 	// print Block
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			PrintBlock(100, 50, 350, 55, BLOCK_OVERWRITE, 0);
			PrintBlock(100, 50, 350, 150, BLOCK_SLOPE, 10);
			PrintBlock(100, 150, 350, 350, BLOCK_BOX, 10);
			Prints(1, 1);

			menu_flag = 7;
		}
		else if (8 == input) 	// check status
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			status = CheckPrinterStatus();

			if (status & STS_RIBONEND)
			{
				printf("\n status : ribon end\n");
			}

			if (status & STS_GAPERROR)
			{
				printf("\n status : gap error\n");
			}

			if (status & STS_TPHOVERHEAT)
			{
				printf("\n status : TPH overheat\n");
			}

			if (status & STS_CUTTERJAM)
			{
				printf("\n status : cutter jam\n");
			}

			if (status & STS_COVEROPEN)
			{
				printf("\n status : cover open\n");
			}

			if (status & STS_PAPEREMPTY)
			{
				printf("\n status : paper empty\n");
			}

			if (0x00 == status)
			{
				printf("\n status : Normal\n");
			}

			sleep(1);

			menu_flag = 8;
		}
		else if (9 == input) 	// calibrate media
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			CalibrateMedia();

			menu_flag = 9;
		}
		else if (10 == input) 	// exit
		{
			DisconnectPrinter();			
			break;
		}
		else 
		{
			printf("Wrong Input!!\n");

			continue;
		}
	}

	return 0;
}

